精华内容
下载资源
问答
  • JAVA throws

    2013-03-07 13:37:49
    int div(int a,int b) throws Exception//在功能上通过throws的关键字声明该功能可能出现问题 { return a/b; } } class ExceptionDemo { public static void main(String[]args) //throws Exceptio

    //仅作为学习笔记


    
    class Demo
    {
    	int div(int a,int b) throws Exception//在功能上通过throws的关键字声明该功能可能出现问题
    	{
    		return a/b;
    	}
    }
    
    
    class ExceptionDemo
    {
    		public static void main(String[]args) //throws Exception
    		{
    			Demo d = new Demo();
    
    		try
    		{
    				int x = d.div(4,0);
    				//int x = d.div(4,1);
    				System.out.println("x="+x);	
    		}
    		catch (Exception e)
    		{
    			System.out.println(e.toString());
    		}
    		
    			System.out.println("Over");
    		}
    
    }


    展开全文
  • Java throws 使用

    万次阅读 热门讨论 2018-01-26 23:12:11
    针对这种情况,Java总允许在方法的后面使用throws关键字对外声明该方法有可能发生异常,这样调用者在调用方法时,就明确地知道该方法有异常,并且必须在程序中对异常进行处理,否则编译无法通过。 如下面代码 ...

    在开发中,如果去调用别人写的方法时,是否能知道别人写的方法是否会发生异常?这是很难判断的。针对这种情况,Java总允许在方法的后面使用throws关键字对外声明该方法有可能发生异常,这样调用者在调用方法时,就明确地知道该方法有异常,并且必须在程序中对异常进行处理,否则编译无法通过。

    如下面代码


    package www.kangxg.jdbc;
    
    public class Example {
    
        public static void main(String[] args) {
            // TODO Auto-generated method stub
           int result = divide(4,2);
           System.out.println(result);
        }
        
        public static int divide(int x,int y) throws Exception
        {
            int result = x/y;
            return result;
        }
    
    }
    
    这时候 编译器上会有错误提示  Unhandled exception type Exception

    所以需要对调用divide()方法进行try...catch处理


    package www.kangxg.jdbc;
    
    public class Example {
    
        public static void main(String[] args) {
            
          try {
             int    result = divide(4,2);
              System.out.println(result);
           } catch (Exception e) {
            
              e.printStackTrace();
           }
          
        }
        
        public static int divide(int x,int y) throws Exception
        {
            int result = x/y;
            return result;
        }
    
    }

    debug 运行程序

    当 调用divide()方法时,如果不知道如何处理声明抛出的异常,也可以使用throws 关键字继续抛异常,这样程序也能编译运行。但是注意的是,程序一旦发生异常,如果没有被处理,程序就会非正常终止。如下:

    package www.kangxg.jdbc;
    
    public class Example {
    
        public static void main(String[] args) throws Exception {
            
              int    result = divide(4,0);
              System.out.println(result);
          
        }
        
        public static int divide(int x,int y) throws Exception
        {
            int result = x/y;
            return result;
        }
    
    }

      

    debug运行程序

     

     



    Java 运行时异常与编译时异常

    1. 编译时异常

       在Java 中,Exception类中除了RuntimeException 类及其子类外都是编译时异常。编译时异常的特点是Java编译器会对其进行检查,如果出现异常就必须对异常进行处理,否则程序无法编译通过。

      处理方法

       使用try... catch 语句对异常进行捕获

       使用throws 关键字声明抛出异常,调用者对其进行处理

    2.运行时异常

      RuntimeException 类及其子类运行异常。运行时异常的特点是Java编译器不会对其进行检查。也就是说,当程序中出现这类异常时,即使没有使用try... catch 语句捕获使用throws关键字声明抛出。程序也能编译通过。运行时异常一般是程序中的逻辑错误引起的,在程序运行时无法修复。例如 数据取值越界。

    三 自定义异常

      JDK中定义了大量的异常类,虽然这些异常类可以描述编程时出现的大部分异常情况,但是在程序开发中有时可能需要描述程序中特有的异常情况。例如divide()方法中不允许被除数为负数。为类解决这个问题,在Java中允许用户自定义异常,但自定义的异常类必须继承自Exception或其子类。例子如下


    package www.kangxg.jdbc;
    
    public class DivideDivideByMinusException  extends Exception {
        
        /**
         * 
         */
        private static final long serialVersionUID = 1L;
    
        public DivideDivideByMinusException(){
            super();
        }
        
        public DivideDivideByMinusException(String message)
        {
            super(message);
        }
    }
    

     

    package www.kangxg.jdbc;
    
    public class Example {
    
        public static void main(String[] args) throws Exception {
            
            try {
                 int    result = divide(4,-2);
                  System.out.println(result);
             } catch (DivideDivideByMinusException e) {
                
                 System.out.println(e.getMessage());
             }
          
        }
        
        public static int divide(int x,int y) throws DivideDivideByMinusException
        {
            if(y<0)
            {
                throw new DivideDivideByMinusException("被除数是负数");
            }
            int result = x/y;
            return result;
        }
    
    }

      

    Debug 运行


     


    展开全文
  • java throws处理

    2013-07-12 11:24:15
    View Code 1 class Math{ 2 public int div(int i,int j) throws Exception{ 3 int t=i/j; 4 return t; 5 } 6 } 7 public class ThrowsDemo { 8 public static void main(String a
    View Code
     1 class Math{
    2 public int div(int i,int j) throws Exception{
    3 int t=i/j;
    4 return t;
    5 }
    6 }
    7 public class ThrowsDemo {
    8 public static void main(String args[]) throws Exception{
    9 Math m=new Math();
    10 System.out.println("出发操作:"+m.div(10,2));
    11 }
    12 }

    主方法使用throws关键字

    展开全文
  • 下面两个类中分别有一个throws方法,在第一个类中的throws方法中没有声明throws抛出异常,在第二个声明了throws抛出异常,执行两个类,结果相同。而第二个类中throws方法声明的throws抛出异常有什么用啊,这样写不是...
  • JAVA throws和throw的区别

    2013-03-07 20:21:49
    throws 和throw的区别 1,throws使用在函数上。 2,throw使用在函数内。 throws后面跟的异常类可以跟多个,用逗号隔开 throw后面跟的是异常对象。 */ class FuShuException extends Exception { private int ...

    //仅作为学习笔记


    /*
    
    throws 和throw的区别
    1,throws使用在函数上。
    2,throw使用在函数内。
    
    throws后面跟的异常类可以跟多个,用逗号隔开
    throw后面跟的是异常对象。
    
    */
    
    
    
    class FuShuException extends Exception
    {
    	private int value;
    	FuShuException(String msg,int value)
    	{
    		super(msg);
    		this.value = value;
    	}
    
    	public int getValue()
    	{
    		return value;
    	}
    }
    
    
    
    class Demo
    {
    	int div(int a,int b)throws FuShuException//throws定义在函数上
    	{
    		if(b < 0)
    		{
    			throw new FuShuException("出现了除数是负数的情况!",b);//throws定义在函数内
    		}
    		return a/b;
    	}
    }
    
    class ExceptionDemo3 
    {
    	public static void main(String[] args) 
    	{
    
    		Demo d = new Demo();
    
    
    		try
    		{
    			int x = d.div(4,-1);							
    			System.out.println(" x = "+ x);
    		}
    		catch (FuShuException e)
    		{
    			System.out.println(e.toString());
    			System.out.println("出现错误的数是:"+e.getValue());
    		}
    
    	}
    }
    


    展开全文
  • Javathrows

    2019-03-17 22:17:00
    抛出异常: throw:手动抛出异常 声明异常: thorws:声明方法可能要抛出的各种异常 ... void w() throws Normal{ throw new Normal(); } void dispose() throws Exception{ throw new Imp...
  • Javathrows Exception

    万次阅读 2019-04-21 13:24:02
    )throwsException放在方法后边,是throwsException表示的是本方法不处理异常,交给被调用处处理(如果你不希望异常层层往上抛,你就要用throws Exception),而且被调用处必须处理。 2、throw new Exce...
  • javathrows关键字用法

    千次阅读 2018-11-23 20:38:12
    定义一个方法的时候可以使用throws关键字声明。使用throws关键字声明的方法表示此方法不处理异常,而交给方法调用处进行处理。 throws关键字格式: public 返回值类型 方法名称(参数列表,,,)throws 异常类{}...
  • Javathrows IOException什么意思?

    万次阅读 2018-12-19 11:19:01
    throws IOException是Java中的throws语句。 throws是方法可能抛出异常的声明。(用在声明方法时,表示该方法可能要抛出异常) 语法:[(修饰符)](返回值类型)(方法名)([参数列表])[throws(异常类)]{......} public ...
  • javathrows和throw的区别 throws:处理异常的一种方式,把异常抛出,由调用者来处理 用法:public static void checkScore(int score) throws Exception,在方法位置将异常抛出用throws throw:...
  • javathrows异常处理

    2018-10-09 21:42:49
    为了解决出错问题,Java针对这种情况,就提供了另一种处理方案:抛出。   格式:  throws 异常类名  注意:这个格式必须跟在方法的括号后面。    注意:  尽量不要在main方法上抛出异常。    小结...
  • java异常处理 throw throws
  • Java中的throws关键字

    千次阅读 2018-03-31 23:06:37
    1. throws关键字 throws关键字主要用于方法声明上,指的是当方法之中出现异常后交由被调用处处理。范例:使用throwsclass MyMath{ //由于存在throws,那么就表示此方法里面产生的异常交给被调用处处理 public ...
  • 再探java基础——throw与throws

    万次阅读 多人点赞 2013-08-31 14:30:49
    再探java基础——throw与throws 以前虽然知道一些异常的处理,也用过一些,但是对throw和throws区别还是有不太清楚。今天用实例测试一下。 异常处理机制 异常处理是对可能出现的异常进行处理,以防止程序遇到异常...
  • JAVAThrows和Throw的区别

    千次阅读 2017-04-27 09:46:50
    Throw是语句抛出一个异常,写于方法内部;语法:throw (异常对象); throw e;Throws是方法可能抛出异常的声明;语法:[(修饰符)](返回值类型)... public void doA(int a) throws Exception1,Exception3{......}1、t
  • java throw throws try catch

    千次阅读 2011-10-31 17:03:13
     /////java处理异常方式///////////////////////////////  在java代码中如果发生异常的话,jvm会抛出异常对象,导致程序代码中断,这个时候jvm在做的操作就是:创建异常对象,然后抛出,比如:  int i= 1; ...
  • Java中throw和throws

    千次阅读 2011-03-16 13:38:00
    Java中throw和throws
  • java中throw与throws

    千次阅读 2014-05-28 16:18:15
    类或函数声明,用throws表示,函数体中,可能抛出的错误,后接多个。
  • Javathrows和throw的用法

    千次阅读 2017-12-16 21:18:30
    public class Test_Exception { public static void main(String[] args){ int a = 1; int b = 1;... public static void add(int a,int b) throws RuntimeException{ if (a == b) throw ne
  • throws和throw的区别(面试题)  throws  用在方法声明后面,跟的是异常类名  可以跟多个异常类名,用逗号隔开  表示抛出异常,由该方法的调用者来处理  throws表示出现异常的一种可能性,并不一定会发生...
  • Javathrows,throw抛出异常问题

    千次阅读 2017-11-08 15:35:39
    Java中异常的分类,主要分为两大类型 1. 系统自动抛出的异常 所有系统定义的编译和运行异常都可以由系统自动抛出,称为标准异常,并且 Java 强烈地要求应用程序进行完整的异常处理,给用户友好的提示,或者修正后...
  • Javathrows和throw的区别讲解

    千次阅读 2015-09-30 11:59:00
    1、throws关键字通常被应用在声明方法时,用来指定可能抛出的异常。多个异常可以使用逗号隔开。当在主函数中调用该方法时,如果发生异常,就会将异常抛给指定异常对象。如下面例子所示: public class Shoot { 创建...
  • 目录 throws throw throws ... 2.try-catch-finaly 与 throw throws 的区别主要是:try-catch-finaly发现的异常自己在方法内处理,throw throws则是把可能的异常抛出,在调用的他的时候再去检测和处...
  • 在定义一个方法时可以使用throws关键字声明,使用throws声明的方法表示此方法不处理异常,而是交给方法的调用处进行处理,throws的用法:public 返回值类型 方法名称(参数列表,,,)throws 异常类{}【使用throws...
  • throw和throws作为Java中两种异常抛出关键字,虽然两个长的很像,但是却有着很大的区别。 区别1: throws: 跟在方法声明后面,后面跟的是异常类名 throw: 用在方法体内,后面跟的是异常类对象名 public ...
  • 1、Throws 如果在当前方法不知道该如何处理该异常时,则可以使用throws对异常进行抛出给调用者处理或者交给JVM。调用者调用此方法,要么抛出要么try catch处理,到了JVM这里,就是打印出异常堆栈,并终止运行。...
  • Java中的throw和throws的区别

    千次阅读 2014-08-20 23:53:56
    Java中的throw和throws的区别 1、throw关键字用于方法体内部,而throws关键字用于方法体部的方法声明部分; 2、throw用来抛出一个Throwable类型的异常,而throws用来声明方法可能会抛出某些异常
  • )throwsException放在方法后边,是throwsException表示的是本方法不处理异常,交给被调用处处理(如果你不希望异常层层往上抛,你就要用throws Exception),而且被调用处必须处理。 2、throw new Exception表示人为的...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 51,219
精华内容 20,487
关键字:

javathrows

java 订阅